/'
 ' Project Publisher - Installer Creator Addin for FbEdit and RadASM
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "FbEdit.bi"
#Include Once "RadASM.bi"

#Include Once "ProjPub.bi"
#Include Once "Hooks.bi"
#Include Once "Resource.bi"

Function FolderNameEditHook( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As Integer

	Dim OrigWndProg As WNDPROC = Cast( WNDPROC, GetWindowLong( hWin, GWL_USERDATA ) )

	Select Case uMsg
		Case WM_CHAR
			Select Case wParam
				Case /'&h5C,'/ &h2F, &h3A, &h2A, &h3F, &h22, &h3C, &h3E, &h7C
					' \, /, :, *, ?, ", <, >, | cannot be used in folder name
					Return 0
			End Select
			'
		Case WM_PASTE
			' Check if clipboard contains invalid characters
			Dim ClipboardContents As String
			Dim hGlobal As HGLOBAL
			Dim ClipboardData As ZString Ptr
			If IsClipboardFormatAvailable( CF_TEXT ) Then
				If OpenClipboard( hWin ) Then
					hGlobal = GetClipboardData( CF_TEXT )
					If hGlobal Then
						ClipboardData = GlobalLock( hGlobal )
						If ClipboardData Then
							ClipboardContents = *ClipboardData
							GlobalUnlock( hGlobal )
						End If
					End If
					CloseClipboard(  )
					If InStr( ClipboardContents, Any "/:*?""<>|" ) Then Return 0
				End If
			End If
			'
	End Select

	Return CallWindowProc( OrigWndProg, hWin, uMsg, wParam, lParam )

End Function

Function KeyNameEditHook( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As Integer

	Dim OrigWndProg As WNDPROC = Cast( WNDPROC, GetWindowLong( hWin, GWL_USERDATA ) )

	Select Case uMsg
		Case WM_CHAR
			Select Case wParam
				Case &h5C, &h2A, &h3F, &h32
					' \, *, ?, space cannot be used in folder name
					Return 0
			End Select
			'
		Case WM_PASTE
			' Check if clipboard contains invalid characters
			Dim ClipboardContents As String
			Dim hGlobal As HGLOBAL
			Dim ClipboardData As ZString Ptr
			If IsClipboardFormatAvailable( CF_TEXT ) Then
				If OpenClipboard( hWin ) Then
					hGlobal = GetClipboardData( CF_TEXT )
					If hGlobal Then
						ClipboardData = GlobalLock( hGlobal )
						If ClipboardData Then
							ClipboardContents = *ClipboardData
							GlobalUnlock( hGlobal )
						End If
					End If
					CloseClipboard(  )
					If InStr( ClipboardContents, Any "\*? " ) Or _
						Left( ClipboardContents, 1 ) = "." Then Return 0
				End If
			End If
			'
	End Select

	Return CallWindowProc( OrigWndProg, hWin, uMsg, wParam, lParam )

End Function

