/'
 ' Project Publisher - Installer Creator Addin for FbEdit and RadASM
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "FbEdit.bi"
#Include Once "RadASM.bi"

#Include Once "ProjPub.bi"
#Include Once "Settings.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "InstallFolder.bi"
#Include Once "Resource.bi"

Function InstallFolderDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4010", "Install Folder" ), _
				GetTranslateString( "4011", "Choose the default installation folder." ) _
				)

			' Translate dialog box
			If CurIDE = IDE_FBEDIT Then
				lpFbEFunctions->TranslateAddinDialog( hWin, ADDIN_NAME )
			End If

			' Set limit of text
			SendDlgItemMessage( hWin, IDC_EDTINSTFOLDER, EM_SETLIMITTEXT, MAX_PROJSETTINGS_INSTFOLDER, NULL )
			SendDlgItemMessage( hWin, IDC_EDTINSTFOLDERREQUIRE, EM_SETLIMITTEXT, MAX_PATH, NULL )

			' Set defaults
			SetDlgItemText( hWin, IDC_EDTINSTFOLDER, @ProjectSettings.InstallFolder )
			SetDlgItemText( hWin, IDC_EDTINSTFOLDERREQUIRE, @ProjectSettings.RequireInstallFolder )

			' Set require
			If ProjectSettings.ProjectType = PROJPUB_PROJTYPE_APPPLUGIN Or ProjectSettings.RequireInstallFolder <> "" Then
				CheckDlgButton( hWin, IDC_CHKINSTFOLDERREQUIRE, BST_CHECKED )
				EnableDlgItem( hWin, IDC_EDTINSTFOLDERREQUIRE, TRUE )
			Else
				EnableDlgItem( hWin, IDC_EDTINSTFOLDERREQUIRE, FALSE )
			End If
			'
		Case WM_COMMAND
			Select Case LoWord( wParam )
				Case IDC_CHKINSTFOLDERREQUIRE
					If IsDlgButtonChecked( hWin, IDC_CHKINSTFOLDERREQUIRE ) = BST_CHECKED Then
						EnableDlgItem( hWin, IDC_EDTINSTFOLDERREQUIRE, TRUE )
					Else
						EnableDlgItem( hWin, IDC_EDTINSTFOLDERREQUIRE, FALSE )
					End If
					'
			End Select
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					If ProjectSettings.ProjectType = PROJPUB_PROJTYPE_FBEADDIN Then
						ProjectSettings.InstallFolder = "FbEdit"
						ProjectSettings.RequireInstallFolder = "FbEdit.exe"
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
						Return TRUE
					End If
					'
				Case PSN_WIZNEXT
					GetDlgItemText( hWin, IDC_EDTINSTFOLDER, @ProjectSettings.InstallFolder, MAX_PROJSETTINGS_INSTFOLDER )
					If IsDlgButtonChecked( hWin, IDC_CHKINSTFOLDERREQUIRE ) = BST_CHECKED Then
						GetDlgItemText( hWin, IDC_EDTINSTFOLDERREQUIRE, @ProjectSettings.RequireInstallFolder, MAX_PATH )
						If ProjectSettings.RequireInstallFolder = "" Then
							ErrorBox( hWin, GetTranslateString( "5006", "Requiring a file in installation folder is enabled, but there is no file specified to be checked if existing." ) )
							SetWindowLong( hWin, DWL_MSGRESULT, -1 )
							Return -1
						End If
					End If
					If ProjectSettings.InstallFolder = "" Then
						ErrorBox( hWin, GetTranslateString( "5001", "Installation folder is required." ) )
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
						Return -1
					End If
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

