/'
 ' Project Publisher - Installer Creator Addin for FbEdit and RadASM
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "FbEdit.bi"
#Include Once "RadASM.bi"

#Include Once "ProjPub.bi"
#Include Once "Settings.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "ProjType.bi"
#Include Once "Resource.bi"

Function ProjTypeDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4000", "Project Type" ), _
				GetTranslateString( "4001", "Choose the type of your project." ) _
				)

			' Translate dialog box
			If CurIDE = IDE_FBEDIT Then
				lpFbEFunctions->TranslateAddinDialog( hWin, ADDIN_NAME )
			End If

			' Set default project type
			If ProjectSettings.ProjectType = PROJPUB_PROJTYPE_BASIC Then
				CheckDlgButton( hWin, IDC_RBNPROJTYPEBASIC, BST_CHECKED )
			ElseIf ProjectSettings.ProjectType = PROJPUB_PROJTYPE_GAME Then
				CheckDlgButton( hWin, IDC_RBNPROJTYPEGAME, BST_CHECKED )
			ElseIf ProjectSettings.ProjectType = PROJPUB_PROJTYPE_FBEADDIN Then
				CheckDlgButton( hWin, IDC_RBNPROJTYPEFBEADDIN, BST_CHECKED )
			ElseIf ProjectSettings.ProjectType = PROJPUB_PROJTYPE_ADVANCE Then
				CheckDlgButton( hWin, IDC_RBNPROJTYPEADVANCE, BST_CHECKED )
			ElseIf ProjectSettings.ProjectType = PROJPUB_PROJTYPE_GTKP Then
				CheckDlgButton( hWin, IDC_RBNPROJTYPEGTKP, BST_CHECKED )
			ElseIf ProjectSettings.ProjectType = PROJPUB_PROJTYPE_APPPLUGIN Then
				CheckDlgButton( hWin, IDC_RBNPROJTYPEAPPPLUGIN, BST_CHECKED )
			Else
				CheckDlgButton( hWin, IDC_RBNPROJTYPEBASIC, BST_CHECKED )
			End If
			'
		Case WM_COMMAND
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					'
				Case PSN_WIZNEXT
					If IsDlgButtonChecked( hWin, IDC_RBNPROJTYPEBASIC ) = BST_CHECKED Then
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_BASIC
					ElseIf IsDlgButtonChecked( hWin, IDC_RBNPROJTYPEGAME ) = BST_CHECKED Then
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_GAME
					ElseIf IsDlgButtonChecked( hWin, IDC_RBNPROJTYPEFBEADDIN ) = BST_CHECKED Then
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_FBEADDIN
					ElseIf IsDlgButtonChecked( hWin, IDC_RBNPROJTYPEADVANCE ) = BST_CHECKED Then
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_ADVANCE
					ElseIf IsDlgButtonChecked( hWin, IDC_RBNPROJTYPEGTKP ) = BST_CHECKED Then
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_GTKP
					ElseIf IsDlgButtonChecked( hWin, IDC_RBNPROJTYPEAPPPLUGIN ) = BST_CHECKED Then
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_APPPLUGIN
					End If
					DisableUnneededFeatures
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

