/'
 ' Project Publisher - Installer Creator Addin for FbEdit and RadASM
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "FbEdit.bi"
#Include Once "RadASM.bi"

#Include Once "ProjPub.bi"
#Include Once "Settings.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "RemDrvInst.bi"
#Include Once "Resource.bi"

Function RemDrvInstDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4016", "Installing in Removable Drives" ), _
				GetTranslateString( "4017", "Choose whether installing in removable drives is supported." ) _
				)

			' Translate dialog box
			If CurIDE = IDE_FBEDIT Then
				lpFbEFunctions->TranslateAddinDialog( hWin, ADDIN_NAME )
			End If

			' Set defaults
			If ProjectSettings.RemDrvInst = PROJPUB_REMDRVINST_ADDOPTION Then
				CheckDlgButton( hWin, IDC_RBNREMDRVINSTOPTION, BST_CHECKED )
				EnableDlgItem( hWin, IDC_CHKREMDRVINSTNOUNINST, TRUE )
			ElseIf ProjectSettings.RemDrvInst = PROJPUB_REMDRVINST_SILENTCHECK Then
				CheckDlgButton( hWin, IDC_RBNREMDRVINSTSILENT, BST_CHECKED )
				EnableDlgItem( hWin, IDC_CHKREMDRVINSTNOUNINST, TRUE )
			ElseIf ProjectSettings.RemDrvInst = PROJPUB_REMDRVINST_DISABLE Then
				CheckDlgButton( hWin, IDC_RBNREMDRVINSTOPTION, BST_CHECKED )
				EnableDlgItem( hWin, IDC_CHKREMDRVINSTNOUNINST, FALSE )
			Else
				CheckDlgButton( hWin, IDC_RBNREMDRVINSTOPTION, BST_CHECKED )
				EnableDlgItem( hWin, IDC_CHKREMDRVINSTNOUNINST, TRUE )
			End If
			If ProjectSettings.RemDrvInstUninst Then
				CheckDlgButton( hWin, IDC_CHKREMDRVINSTNOUNINST, BST_CHECKED )
			End If
			'
		Case WM_COMMAND
			Select Case HiWord( wParam )
				Case BN_CLICKED
					Select Case LoWord( wParam )
						Case IDC_RBNREMDRVINSTOPTION
							If IsDlgButtonChecked( hWin, IDC_RBNREMDRVINSTOPTION ) = BST_CHECKED Then
								EnableDlgItem( hWin, IDC_CHKREMDRVINSTNOUNINST, TRUE )
							End If
							'
						Case IDC_RBNREMDRVINSTSILENT
							If IsDlgButtonChecked( hWin, IDC_RBNREMDRVINSTSILENT ) = BST_CHECKED Then
								EnableDlgItem( hWin, IDC_CHKREMDRVINSTNOUNINST, TRUE )
							End If
							'
						Case IDC_RBNREMDRVINSTDISABLE
							If IsDlgButtonChecked( hWin, IDC_RBNREMDRVINSTDISABLE ) = BST_CHECKED Then
								EnableDlgItem( hWin, IDC_CHKREMDRVINSTNOUNINST, FALSE )
							End If
							'
					End Select
					'
			End Select
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					If ProjectSettings.ProjectType = PROJPUB_PROJTYPE_BASIC Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_GAME Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_APPPLUGIN Then
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
						Return TRUE
					End If
				Case PSN_WIZNEXT
					If IsDlgButtonChecked( hWin, IDC_RBNREMDRVINSTOPTION ) = BST_CHECKED Then
						ProjectSettings.RemDrvInst = PROJPUB_REMDRVINST_ADDOPTION
					ElseIf IsDlgButtonChecked( hWin, IDC_RBNREMDRVINSTSILENT ) = BST_CHECKED Then
						ProjectSettings.RemDrvInst = PROJPUB_REMDRVINST_SILENTCHECK
					ElseIf IsDlgButtonChecked( hWin, IDC_RBNREMDRVINSTOPTION ) = BST_CHECKED Then
						ProjectSettings.RemDrvInst = PROJPUB_REMDRVINST_DISABLE
					End If
					If IsDlgButtonChecked( hWin, IDC_CHKREMDRVINSTNOUNINST ) = BST_CHECKED Then
						ProjectSettings.RemDrvInstUninst = 1
					Else
						ProjectSettings.RemDrvInstUninst = 0
					End If
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

