/'
 ' Project Publisher - Installer Creator Addin for FbEdit and RadASM
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "FbEdit.bi"
#Include Once "RadASM.bi"

#Include Once "ProjPub.bi"
#Include Once "Settings.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "Shortcuts.bi"
#Include Once "Resource.bi"

Function ShortcutsDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4018", "Shortcuts" ), _
				GetTranslateString( "4019", "Choose the shortcuts you want to be installed with your program." ) _
				)

			' Translate dialog box
			If CurIDE = IDE_FBEDIT Then
				lpFbEFunctions->TranslateAddinDialog( hWin, ADDIN_NAME )
			End If

			' Set limit of text
			SendDlgItemMessage( hWin, IDC_EDTSHORTCUTSFOLDER, EM_SETLIMITTEXT, MAX_PATH, NULL )

			' Set defaults
			SetDlgItemText( hWin, IDC_EDTSHORTCUTSFOLDER, @ProjectSettings.Name )
			If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_MAINPROGRAM ) <> NULL Then
				CheckDlgButton( hWin, IDC_CHKSHORTCUTSMAIN, BST_CHECKED )
			End If
			If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_UNINSTALLER ) <> NULL Then
				CheckDlgButton( hWin, IDC_CHKSHORTCUTSUNINST, BST_CHECKED )
			End If
			If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_PRJWEBSITE ) <> NULL Then
				CheckDlgButton( hWin, IDC_CHKSHORTCUTSWEBSITE, BST_CHECKED )
			End If
			If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_MAININDESKTOP ) <> NULL Then
				CheckDlgButton( hWin, IDC_CHKSHORTCUTSDESKTOPMAIN, BST_CHECKED )
			End If
			'
		Case WM_COMMAND
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					If ProjectSettings.ProjectLink = "" Then
						EnableDlgItem( hWin, IDC_CHKSHORTCUTSWEBSITE, FALSE )
					End If
					If ProjectSettings.ProjectType = PROJPUB_PROJTYPE_FBEADDIN Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_APPPLUGIN Then
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
						Return TRUE
					End If
					'
				Case PSN_WIZNEXT
					ProjectSettings.ShortcutOptions = NULL
					If IsDlgButtonChecked( hWin, IDC_CHKSHORTCUTSMAIN ) = BST_CHECKED Then
						ProjectSettings.ShortcutOptions Or= PROJPUB_SHORTCUT_MAINPROGRAM
					Else
						ProjectSettings.ShortcutOptions And= Not PROJPUB_SHORTCUT_MAINPROGRAM
					End If
					If IsDlgButtonChecked( hWin, IDC_CHKSHORTCUTSUNINST ) = BST_CHECKED Then
						ProjectSettings.ShortcutOptions Or= PROJPUB_SHORTCUT_UNINSTALLER
					Else
						ProjectSettings.ShortcutOptions And= Not PROJPUB_SHORTCUT_UNINSTALLER
					End If
					If IsDlgButtonChecked( hWin, IDC_CHKSHORTCUTSWEBSITE ) = BST_CHECKED Then
						ProjectSettings.ShortcutOptions Or= PROJPUB_SHORTCUT_PRJWEBSITE
					Else
						ProjectSettings.ShortcutOptions And= Not PROJPUB_SHORTCUT_PRJWEBSITE
					End If
					If IsDlgButtonChecked( hWin, IDC_CHKSHORTCUTSDESKTOPMAIN ) = BST_CHECKED Then
						ProjectSettings.ShortcutOptions Or= PROJPUB_SHORTCUT_MAININDESKTOP
					Else
						ProjectSettings.ShortcutOptions And= Not PROJPUB_SHORTCUT_MAININDESKTOP
					End If
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

