#Define NULL 0

Type ProjPub_File
	Name As ZString Ptr
	Next As ProjPub_File Ptr
End Type

Type ProjPub_Folder
	Name As ZString Ptr
	Next As ProjPub_Folder Ptr
	File As ProjPub_File Ptr
End Type

Sub AddFileToFolder( _
	ByRef File As Const String, _
	ByVal Folder As ProjPub_Folder Ptr _
	)

	If Folder = NULL Then Return

	Dim lpPPFile As ProjPub_File Ptr

	If Folder->File = NULL Then
		Folder->File = New ProjPub_File
		lpPPFile = Folder->File
	Else
		lpPPFile = Folder->File
		Do While lpPPFile->Next <> NULL
			lpPPFile = lpPPFile->Next
		Loop
		lpPPFile->Next = New ProjPub_File
		lpPPFile = lpPPFile->Next
	End If

	lpPPFile->Name = Cast( ZString Ptr, New Byte[ Len( File ) + 1 ] )
	*lpPPFile->Name = File

End Sub

Sub AddFolder( _
	ByVal FolderName As String, _
	ByVal lpFolder As ProjPub_Folder Ptr Ptr _
	)

	If lpFolder = NULL Then Return

	*lpFolder = New ProjPub_Folder
	(*lpFolder)->Name = Cast( ZString Ptr, New Byte[ Len( FolderName ) + 1 ] )
	*(*lpFolder)->Name = FolderName

End Sub

Sub FreeFiles( _
	ByVal File As ProjPub_File Ptr Ptr _
	)

	If File = NULL Then Return

	Dim lpPPFile As ProjPub_File Ptr = *File
	Dim lpPPTempFile As ProjPub_File Ptr

	Do While lpPPFile <> NULL
		lpPPTempFile = lpPPFile->Next
		Delete[] lpPPFile->Name
		Delete lpPPFile
		lpPPFile = lpPPTempFile
	Loop

	*File = NULL

End Sub

Sub FreeFolders( _
	ByVal Folder As ProjPub_Folder Ptr Ptr _
	)

	If Folder = NULL Then Return

	Dim lpPPFolder As ProjPub_Folder Ptr = *Folder
	Dim lpPPTempFolder As ProjPub_Folder Ptr

	Do While lpPPFolder <> NULL
		lpPPTempFolder = lpPPFolder->Next
		FreeFiles( @lpPPFolder->File )
		Delete[] lpPPFolder->Name
		Delete lpPPFolder
		lpPPFolder = lpPPTempFolder
	Loop

	*Folder = NULL

End Sub

Sub PrintFiles( _
	ByVal File As ProjPub_File Ptr _
	)

	Dim lpPPFile As ProjPub_File Ptr = File

	Do While lpPPFile <> NULL
		Print !"\t" & *lpPPFile->Name
		lpPPFile = lpPPFile->Next
	Loop
	
End Sub

Sub PrintFolderFiles( _
	ByVal Folder As ProjPub_Folder Ptr _
	)

	Dim lpPPFolder As ProjPub_Folder Ptr = Folder

	Do While lpPPFolder <> NULL
		Print "Folder " & *lpPPFolder->Name & " have files: "
		PrintFiles( lpPPFolder->File )
		lpPPFolder = lpPPFolder->Next
	Loop
	
End Sub

Function GetFolderSibling( _
	ByVal Folder As ProjPub_Folder Ptr, _
	ByVal SiblingId As Integer _
	) As ProjPub_Folder Ptr

	Dim lpPPFolder As ProjPub_Folder Ptr = Folder
	Dim lpPPTempFolder As ProjPub_Folder Ptr

	If SiblingId = 0 Then Return Folder

	For i As Integer = 1 To SiblingId
		lpPPFolder = lpPPFolder->Next
		If lpPPFolder = NULL Then Return NULL
	Next

	Return lpPPFolder

End Function

Function GetFolderLast( _
	ByVal Folder As ProjPub_Folder Ptr _
	) As ProjPub_Folder Ptr

	Dim lpPPFolder As ProjPub_Folder Ptr = Folder

	Do While lpPPFolder->Next <> NULL
		lpPPFolder = lpPPFolder->Next
	Loop

	Return lpPPFolder

End Function

Function GetLastFolderSlot( _
	ByVal Folder As ProjPub_Folder Ptr Ptr _
	) As ProjPub_Folder Ptr Ptr

	If Folder = NULL Then Return NULL

	If (*Folder) = NULL Then Return Folder

	Dim lpPPFolder As ProjPub_Folder Ptr Ptr = Folder

	Do While (*lpPPFolder)->Next <> NULL
		lpPPFolder = @(*lpPPFolder)->Next
	Loop

	Return @(*lpPPFolder)->Next

End Function

Sub RemoveFolder( _
	ByVal Folder As ProjPub_Folder Ptr Ptr, _
	ByVal Id As Integer _
	)

	Dim lpPPFolder As ProjPub_Folder Ptr Ptr = Folder
	Dim lpPPFolderTemp As ProjPub_Folder Ptr Ptr
	
	For i As Integer = 0 To Id
		If i = Id Then
			lpPPFolderTemp = lpPPFolder
			*lpPPFolder = (*lpPPFolder)->Next
			FreeFiles( @(*lpPPFolderTemp)->File )
			Print *(*lpPPFolderTemp)->Name
			Delete *lpPPFolderTemp
			Exit For
		Else
			lpPPFolder = @(*lpPPFolder)->Next
		End If
	Next

End Sub

Dim Folder As ProjPub_Folder Ptr
AddFolder( "FreeBASIC", GetLastFolderSlot( @Folder ) )
AddFileToFolder( "fbc.exe", Folder )
AddFileToFolder( "readme.txt", Folder )
AddFolder( "NSIS", GetLastFolderSlot( @Folder ) )
AddFileToFolder( "makensis.exe", GetFolderLast( Folder ) )
AddFileToFolder( "makensisw.exe", GetFolderLast( Folder ) )
AddFileToFolder( "nsis.exe", GetFolderLast( Folder ) )
AddFolder( "Evince", GetLastFolderSlot( @Folder ) )
AddFileToFolder( "evince.exe", GetFolderLast( Folder ) )
AddFileToFolder( "hello.c", GetFolderSibling( Folder, 0 ) )
PrintFolderFiles( Folder )
Print "Remove NSIS Folder"
RemoveFolder( @Folder, 0 )
PrintFolderFiles( Folder )
Print "Free now..."
FreeFolders( @Folder )
Print "Folder is " & Folder

Sleep