Type File
	Name As ZString Ptr
	Next As File Ptr
End Type

Type Folder
	Name As ZString Ptr
	Next As Folder Ptr
	File As File
End Type

Sub RemoveFileInFolder( _
	ByVal Folder As Folder Ptr, _
	ByVal id As Integer _
	)

	Dim CurFile As File Ptr = @Folder->File
	Dim PrevFile As File Ptr

	For i As Integer = 0 To id
		If CurFile = 0 Then Return
		PrevFile = CurFile
		CurFile = CurFile->Next
	Next

	PrevFile->Next=CurFile->Next
	Delete[] CurFile->Name
	Delete CurFile

End Sub

Sub RemoveAllFilesInFolder( _
	ByVal Folder As Folder Ptr _
	)

	Dim NextFile As File Ptr

	Do While (@Folder->File)->Next <> 0
		NextFile=(@Folder->File)->Next->Next
		Delete[] (@Folder->File)->Next->Name
		Delete (@Folder->File)->Next
		Print "Freed"
		(@Folder->File)->Next=NextFile
	Loop

End Sub

Sub RemoveFolder( _
	ByVal Head As Folder Ptr, _
	ByVal id As Integer _
	)

	Dim CurFolder As Folder Ptr = Head
	Dim PrevFolder As Folder Ptr

	For i As Integer = 0 To id
		If CurFolder = 0 Then Return
		PrevFolder = CurFolder
		CurFolder = CurFolder->Next
	Next

	PrevFolder->Next=CurFolder->Next
	Delete[] CurFolder->Name
	RemoveAllFilesInFolder( CurFolder )
	Delete CurFolder

End Sub

Sub RemoveAllFolders( _
	ByVal Head As Folder Ptr _
	)

	Dim NextFolder As Folder Ptr

	Do While Head->Next <> 0
		NextFolder=Head->Next->Next
		Delete[] Head->Next->Name
		RemoveAllFilesInFolder( Head->Next )
		Delete Head->Next
		Print "Freed"
		Head->Next=NextFolder
	Loop

End Sub

Sub InsertFileToFolderToEnd( _
	ByVal Folder As Folder Ptr, _
	ByVal FileName As String _
	)

	Dim CurFile As File Ptr = @Folder->File

	Do While CurFile->Next <> 0
		CurFile = CurFile->Next
	Loop

	CurFile->Next = New File
	CurFile->Next->Name = New Byte [Len( FileName ) + 1]
	*CurFile->Next->Name = FileName
	CurFile->Next->Next = 0

End Sub

Sub InsertFileToFolder( _
	ByVal Folder As Folder Ptr, _
	ByVal Id As Integer, _
	ByVal FileName As String _
	)

	Dim CurFile As File Ptr = @Folder->File
	Dim TempFile As File Ptr
	Dim CurFileId As Integer = 0

	Do Until CurFileId = Id
		Print "CurFileId is " & CurFileId
		If CurFile->Next <> 0 Then
			Print "CurFile is " & CurFile
			Print "Its name is " & *CurFile->Name
			CurFile = CurFile->Next
		Else
			Return
		End If
		CurFileId += 1
	Loop

	TempFile=CurFile->Next
	CurFile->Next=New File
	CurFile->Next->Name = New Byte [Len( FileName ) + 1]
	*CurFile->Next->Name = FileName
	CurFile->Next->Next=TempFile

End Sub

Function GetFoldersNum( _
	ByVal Head As Folder Ptr _
	) As Integer

	Dim CurFolder As Folder Ptr = Head->Next
	Dim Num As Integer

	Do While CurFolder <> 0
		CurFolder = CurFolder->Next
		Num += 1
	Loop

	Return Num

End Function

Function GetFilesInFolderNum( _
	ByVal Folder As Folder Ptr _
	) As Integer

	Dim CurFile As File Ptr = (@Folder->File)->Next
	Dim Num As Integer

	Do While CurFile <> 0
		CurFile = CurFile->Next
		Num += 1
	Loop

	Return Num

End Function

Sub DisplayFilesInFolder( _
	ByVal Folder As Folder Ptr _
	)

	Dim CurFile As File Ptr = (@Folder->File)->Next

	Do While CurFile <> 0
		Print !"\t" & *CurFile->Name
		CurFile = CurFile->Next
	Loop

	Print !"\tThere are " & GetFilesInFolderNum( Folder ) & " items."

End Sub

Sub DisplayFolder( _
	ByVal Head As Folder Ptr _
	)

	Dim CurFolder As Folder Ptr = Head->Next

	Do While CurFolder <> 0
		Print *CurFolder->Name
		Print !"\tFiles:"
		DisplayFilesInFolder( CurFolder )
		CurFolder = CurFolder->Next
	Loop

	Print "There are " & GetFoldersNum( Head ) & " items."

End Sub

Sub InsertFolderToEnd( _
	ByVal Head As Folder Ptr, _
	ByVal FolderName As String _
	)

	Dim CurFolder As Folder Ptr = Head

	Do While CurFolder->Next <> 0
		CurFolder = CurFolder->Next
	Loop

	CurFolder->Next = New Folder
	CurFolder->Next->Name = New Byte [Len( FolderName ) + 1]
	*CurFolder->Next->Name = FolderName
	CurFolder->Next->Next = 0

End Sub

Sub InsertFolder( _
	ByVal Head As Folder Ptr, _
	ByVal Id As Integer, _
	ByVal FolderName As String _
	)

	Dim CurFolder As Folder Ptr = Head
	Dim TempFolder As Folder Ptr
	Dim CurFolderId As Integer = 0

	Do Until CurFolderId = Id
		Print "CurFolderId is " & CurFolderId
		If CurFolder->Next <> 0 Then
			Print "CurFolder is " & CurFolder
			Print "Its name is " & *CurFolder->Name
			CurFolder = CurFolder->Next
		Else
			Return
		End If
		CurFolderId += 1
	Loop

	TempFolder=CurFolder->Next
	CurFolder->Next=New Folder
	CurFolder->Next->Name = New Byte [Len( FolderName ) + 1]
	*CurFolder->Next->Name = FolderName
	CurFolder->Next->Next=TempFolder

End Sub

Sub ReverseFolders( _
	ByVal Head As Folder Ptr, _
	ByVal Id As Integer _
	)

	Dim PrevFolder As Folder Ptr = Head
	Dim CurFolder As Folder Ptr
	Dim NextFolder As Folder Ptr
	Dim TempFolder As Folder Ptr

	If Id+1>=GetFoldersNum( Head ) Then Return
	For i As Integer = 0 To Id-1
		PrevFolder = PrevFolder->Next
	Next

	CurFolder=PrevFolder->Next
	NextFolder=CurFolder->Next
	TempFolder=PrevFolder->Next
	PrevFolder->Next=CurFolder->Next
	CurFolder->Next=NextFolder->Next
	NextFolder->Next=TempFolder
	
End Sub

Sub ReverseFilesInFolder( _
	ByVal Folder As Folder Ptr, _
	ByVal Id As Integer _
	)

	Dim PrevFile As File Ptr = @Folder->File
	Dim CurFile As File Ptr
	Dim NextFile As File Ptr
	Dim TempFile As File Ptr

	If Id+1>=GetFilesInFolderNum( Folder ) Then Return
	For i As Integer = 0 To Id-1
		PrevFile = PrevFile->Next
	Next

	CurFile=PrevFile->Next
	NextFile=CurFile->Next
	TempFile=PrevFile->Next
	PrevFile->Next=CurFile->Next
	CurFile->Next=NextFile->Next
	NextFile->Next=TempFile
	
End Sub

Sub SetNewFolderName( _
	ByVal Head As Folder Ptr, _
	ByVal Id As Integer, _
	ByVal FolderName As String _
	)

	Dim CurFolder As Folder Ptr = Head

	For i As Integer = 0 To id
		If CurFolder <> 0 Then
			CurFolder = CurFolder->Next
		Else
			Return
		End If
	Next

	Delete[] CurFolder->Name
	CurFolder->Name=New Byte [Len( FolderName ) + 1]
	*CurFolder->Name=FolderName

End Sub

Sub SetNewFileName( _
	ByVal Folder As Folder Ptr, _
	ByVal Id As Integer, _
	ByVal FileName As String _
	)

	Dim CurFile As File Ptr = @Folder->File

	For i As Integer = 0 To id
		If CurFile <> 0 Then
			CurFile = CurFile->Next
		Else
			Return
		End If
	Next

	Delete[] CurFile->Name
	CurFile->Name=New Byte [Len( FileName ) + 1]
	*CurFile->Name=FileName

End Sub

Function GetFolder( _
	ByVal Head As Folder Ptr, _
	ByVal Id As Integer _
	) As Folder Ptr

	Dim CurFolder As Folder Ptr = Head

	For i As Integer = 0 To id
		If CurFolder <> 0 Then
			CurFolder = CurFolder->Next
		Else
			Return 0
		End If
	Next

	Return CurFolder

End Function

Function sortfun( _
	ByVal list As Folder Ptr _
	) As Folder Ptr

	Dim As Integer exchange
	Dim NextFolder As Folder Ptr, CurFolder As Folder Ptr
	Dim As Folder dummy

	/'
	' Algorithm is this:
	' Repeatedly scan list.
	' If two list items are out of order,
	' link them in the other way round.
	' Stop if a full pass is made and no
	' exchanges are required.
	' The whole business is confused by
	' working one element behind the
	' first one of interest.
	' This is because of the simple mechanics of
	' linking and unlinking elements.
	'/

	dummy.Next = list

	Do

		exchange = 0
		CurFolder = @dummy
		NextFolder = CurFolder->Next

		Do

			If NextFolder = 0 Then
				Exit Do
			Else
				If NextFolder->Next = 0 Then
					Exit Do
				End If
			End If

			If *(NextFolder->Name) < *(NextFolder->Next->Name) Then

				/' exchange '/
				exchange = 1
				CurFolder->Next = NextFolder->Next
				NextFolder->Next = CurFolder->Next->Next
				CurFolder->Next->Next = NextFolder

			End If

			CurFolder = CurFolder->Next

		Loop

	Loop While exchange <> 0
	
	Return dummy.Next

End Function


Dim TestHead As Folder
Print "Adding Contents..."
InsertFolderToEnd( @TestHead, "FreeBASIC" )
InsertFileToFolderToEnd( GetFolder( @TestHead, 0 ), "fbc.exe" )
InsertFolderToEnd( @TestHead, "NSIS" )
InsertFileToFolderToEnd( GetFolder( @TestHead, 1 ), "nsis.exe" )
InsertFileToFolder( GetFolder( @TestHead, 1 ), 0, "makensis.exe" )
'SetNewFileName( GetFolder( @TestHead, 1 ), 0, "makensisw.exe" )
'SetNewFolderName( @TestHead, 0, "FreeBASIC" )
ReverseFilesInFolder( GetFolder( @TestHead, 1 ), 0 )
InsertFolderToEnd( @TestHead, "Evince" )
SetNewFolderName( @TestHead, 2, "GIMP" )
Print "Display"
DisplayFolder( @TestHead )
Print "Removing all..."
RemoveAllFolders( @TestHead )

/'
Dim TestHead As Folder
Print "Adding Contents..."
InsertFolderToEnd( @TestHead, "0" )
InsertFolderToEnd( @TestHead, "1" )
InsertFolderToEnd( @TestHead, "2" )
InsertFolderToEnd( @TestHead, "3" )
InsertFolderToEnd( @TestHead, "4" )
Print "Display"
DisplayFolder( @TestHead )
Print "Removing 3..."
RemoveFolder( @TestHead, 3 )
Print "Display"
DisplayFolder( @TestHead )
Print "Removing all..."
RemoveAllFolders( @TestHead )
Print "Display"
DisplayFolder( @TestHead )
Print "Adding New Contents..."
InsertFolderToEnd( @TestHead, "0" )
InsertFolderToEnd( @TestHead, "1" )
InsertFolderToEnd( @TestHead, "2" )
InsertFolderToEnd( @TestHead, "3" )
InsertFolderToEnd( @TestHead, "4" )
Print "Display"
DisplayFolder( @TestHead )
Print "Inserting new content as 1..."
InsertFolder( @TestHead, 1, "5" )
Print "Display"
DisplayFolder( @TestHead )
Print "Inserting new content as 7 (error)..."
InsertFolder( @TestHead, 7, "7" )
Print "Display"
DisplayFolder( @TestHead )
Print "Reverse 4 and 5..."
ReverseFolders( @TestHead, 4 )
Print "Display"
DisplayFolder( @TestHead )
Print "Setting FolderName of 1 to ""3""..."
SetNewFolderName( @TestHead, 1, "3" )
Print "Display"
DisplayFolder( @TestHead )
Print "Removing all..."
RemoveAllFolders( @TestHead )
'/
Sleep