'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                           '
' HtmlHelp.bi                                                               '
'                                                                           '
' Copyright (c) 1996-1997, Microsoft Corp. All rights reserved.             '
'                                                                           '
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

' Converted for FreeBASIC by Arnel A. Borja (galeon@ymail.com)

#Include Once "windows.bi"
#Include Once "win/exdisp.bi"

#inclib "hhctrl.ocx"

#Ifndef __HTMLHELP_BI__
#define __HTMLHELP_BI__

extern "C"

'' Commands to pass to HtmlHelp()

#define HH_DISPLAY_TOPIC        &h0000
#define HH_HELP_FINDER          &h0000  '' WinHelp equivalent
#define HH_DISPLAY_TOC          &h0001  
#define HH_DISPLAY_INDEX        &h0002  
#define HH_DISPLAY_SEARCH       &h0003  
#define HH_SET_WIN_TYPE         &h0004
#define HH_GET_WIN_TYPE         &h0005
#define HH_GET_WIN_HANDLE       &h0006
#define HH_ENUM_INFO_TYPE       &h0007  '' Get Info type name, call repeatedly to enumerate, -1 at end
#define HH_SET_INFO_TYPE        &h0008  '' Add Info type to filter.
#define HH_SYNC                 &h0009
#define HH_RESERVED1            &h000A
#define HH_RESERVED2            &h000B
#define HH_RESERVED3            &h000C
#define HH_KEYWORD_LOOKUP       &h000D
#define HH_DISPLAY_TEXT_POPUP   &h000E  '' display string resource id or text in a popup window
#define HH_HELP_CONTEXT         &h000F  '' display mapped numeric value in dwData
#define HH_TP_HELP_CONTEXTMENU  &h0010  '' text popup help, same as WinHelp HELP_CONTEXTMENU
#define HH_TP_HELP_WM_HELP      &h0011  '' text popup help, same as WinHelp HELP_WM_HELP
#define HH_CLOSE_ALL            &h0012  '' close all windows opened directly or indirectly by the caller
#define HH_ALINK_LOOKUP         &h0013  '' ALink version of HH_KEYWORD_LOOKUP
#define HH_GET_LAST_ERROR       &h0014  '' not currently implemented '' See HHERROR.h
#define HH_ENUM_CATEGORY        &h0015	 '' Get category name, call repeatedly to enumerate, -1 at end
#define HH_ENUM_CATEGORY_IT     &h0016  '' Get category info type members, call repeatedly to enumerate, -1 at end
#define HH_RESET_IT_FILTER      &h0017  '' Clear the info type filter of all info types.
#define HH_SET_INCLUSIVE_FILTER &h0018  '' set inclusive filtering method for untyped topics to be included in display
#define HH_SET_EXCLUSIVE_FILTER &h0019  '' set exclusive filtering method for untyped topics to be excluded from display
#define HH_INITIALIZE           &h001C  '' Initializes the help system.
#define HH_UNINITIALIZE         &h001D  '' Uninitializes the help system.
#define HH_PRETRANSLATEMESSAGE  &h00fd  '' Pumps messages. (NULL, NULL, MSG*). 
#define HH_SET_GLOBAL_PROPERTY  &h00fc  '' Set a global property. (NULL, NULL, HH_GPROP)

#define HHWIN_PROP_TAB_AUTOHIDESHOW (1 shl 0)    '' Automatically hide/show tri-pane window
#define HHWIN_PROP_ONTOP            (1 shl 1)    '' Top-most window
#define HHWIN_PROP_NOTITLEBAR       (1 Shl 2)    '' no title bar
#define HHWIN_PROP_NODEF_STYLES     (1 Shl 3)    '' no default window styles (only HH_WINTYPE.dwStyles)
#define HHWIN_PROP_NODEF_EXSTYLES   (1 Shl 4)    '' no default extended window styles (only HH_WINTYPE.dwExStyles)
#define HHWIN_PROP_TRI_PANE         (1 Shl 5)    '' use a tri-pane window
#define HHWIN_PROP_NOTB_TEXT        (1 Shl 6)    '' no text on toolbar buttons
#define HHWIN_PROP_POST_QUIT        (1 Shl 7)    '' post WM_QUIT message when window closes
#define HHWIN_PROP_AUTO_SYNC        (1 Shl 8)    '' automatically ssync contents and index
#define HHWIN_PROP_TRACKING         (1 Shl 9)    '' send tracking notification messages
#define HHWIN_PROP_TAB_SEARCH       (1 Shl 10)   '' include search tab in navigation pane
#define HHWIN_PROP_TAB_HISTORY      (1 Shl 11)   '' include history tab in navigation pane
#define HHWIN_PROP_TAB_FAVORITES    (1 Shl 12)   '' include favorites tab in navigation pane
#define HHWIN_PROP_CHANGE_TITLE     (1 Shl 13)   '' Put current HTML title in title bar
#define HHWIN_PROP_NAV_ONLY_WIN     (1 Shl 14)   '' Only display the navigation window
#define HHWIN_PROP_NO_TOOLBAR       (1 Shl 15)   '' Don't display a toolbar
#define HHWIN_PROP_MENU             (1 Shl 16)   '' Menu
#define HHWIN_PROP_TAB_ADVSEARCH    (1 Shl 17)   '' Advanced FTS UI.
#define HHWIN_PROP_USER_POS         (1 Shl 18)   '' After initial creation, user controls window size/position
#define HHWIN_PROP_TAB_CUSTOM1      (1 Shl 19)   '' Use custom tab #1
#define HHWIN_PROP_TAB_CUSTOM2      (1 Shl 20)   '' Use custom tab #2
#define HHWIN_PROP_TAB_CUSTOM3      (1 Shl 21)   '' Use custom tab #3
#define HHWIN_PROP_TAB_CUSTOM4      (1 Shl 22)   '' Use custom tab #4
#define HHWIN_PROP_TAB_CUSTOM5      (1 Shl 23)   '' Use custom tab #5
#define HHWIN_PROP_TAB_CUSTOM6      (1 Shl 24)   '' Use custom tab #6
#define HHWIN_PROP_TAB_CUSTOM7      (1 Shl 25)   '' Use custom tab #7
#define HHWIN_PROP_TAB_CUSTOM8      (1 Shl 26)   '' Use custom tab #8
#define HHWIN_PROP_TAB_CUSTOM9      (1 Shl 27)   '' Use custom tab #9
#define HHWIN_TB_MARGIN             (1 Shl 28)   '' the window type has a margin

#define HHWIN_PARAM_PROPERTIES      (1 Shl 1)    '' valid fsWinProperties
#define HHWIN_PARAM_STYLES          (1 Shl 2)    '' valid dwStyles
#define HHWIN_PARAM_EXSTYLES        (1 Shl 3)    '' valid dwExStyles
#define HHWIN_PARAM_RECT            (1 Shl 4)    '' valid rcWindowPos
#define HHWIN_PARAM_NAV_WIDTH       (1 Shl 5)    '' valid iNavWidth
#define HHWIN_PARAM_SHOWSTATE       (1 Shl 6)    '' valid nShowState
#define HHWIN_PARAM_INFOTYPES       (1 Shl 7)    '' valid apInfoTypes
#define HHWIN_PARAM_TB_FLAGS        (1 Shl 8)    '' valid fsToolBarFlags
#define HHWIN_PARAM_EXPANSION       (1 Shl 9)    '' valid fNotExpanded
#define HHWIN_PARAM_TABPOS          (1 Shl 10)   '' valid tabpos
#define HHWIN_PARAM_TABORDER        (1 Shl 11)   '' valid taborder
#define HHWIN_PARAM_HISTORY_COUNT   (1 Shl 12)   '' valid cHistory
#define HHWIN_PARAM_CUR_TAB         (1 Shl 13)   '' valid curNavType

#define HHWIN_BUTTON_EXPAND         (1 Shl 1)    '' Expand/contract button
#define HHWIN_BUTTON_BACK           (1 Shl 2)    '' Back button
#define HHWIN_BUTTON_FORWARD        (1 Shl 3)    '' Forward button
#define HHWIN_BUTTON_STOP           (1 Shl 4)    '' Stop button
#define HHWIN_BUTTON_REFRESH        (1 Shl 5)    '' Refresh button
#define HHWIN_BUTTON_HOME           (1 Shl 6)    '' Home button
#define HHWIN_BUTTON_BROWSE_FWD     (1 Shl 7)    '' not implemented
#define HHWIN_BUTTON_BROWSE_BCK     (1 Shl 8)    '' not implemented
#define HHWIN_BUTTON_NOTES          (1 Shl 9)    '' not implemented
#define HHWIN_BUTTON_CONTENTS       (1 Shl 10)   '' not implemented
#define HHWIN_BUTTON_SYNC           (1 Shl 11)   '' Sync button
#define HHWIN_BUTTON_OPTIONS        (1 Shl 12)   '' Options button
#define HHWIN_BUTTON_PRINT          (1 Shl 13)   '' Print button
#define HHWIN_BUTTON_INDEX          (1 Shl 14)   '' not implemented
#define HHWIN_BUTTON_SEARCH         (1 Shl 15)   '' not implemented
#define HHWIN_BUTTON_HISTORY        (1 Shl 16)   '' not implemented
#define HHWIN_BUTTON_FAVORITES      (1 Shl 17)   '' not implemented
#define HHWIN_BUTTON_JUMP1          (1 Shl 18)
#define HHWIN_BUTTON_JUMP2          (1 Shl 19)
#define HHWIN_BUTTON_ZOOM           (1 Shl 20)
#define HHWIN_BUTTON_TOC_NEXT       (1 Shl 21)
#define HHWIN_BUTTON_TOC_PREV       (1 shl 22)

#define HHWIN_DEF_BUTTONS            _
            (HHWIN_BUTTON_EXPAND Or  _
             HHWIN_BUTTON_BACK Or    _
             HHWIN_BUTTON_OPTIONS Or _
             HHWIN_BUTTON_PRINT)

'' Button IDs

#define IDTB_EXPAND             200
#define IDTB_CONTRACT           201
#define IDTB_STOP               202
#define IDTB_REFRESH            203
#define IDTB_BACK               204
#define IDTB_HOME               205
#define IDTB_SYNC               206
#define IDTB_PRINT              207
#define IDTB_OPTIONS            208
#define IDTB_FORWARD            209
#define IDTB_NOTES              210 '' not implemented
#define IDTB_BROWSE_FWD         211
#define IDTB_BROWSE_BACK        212
#define IDTB_CONTENTS           213 '' not implemented
#define IDTB_INDEX              214 '' not implemented
#define IDTB_SEARCH             215 '' not implemented
#define IDTB_HISTORY            216 '' not implemented
#define IDTB_FAVORITES          217 '' not implemented
#define IDTB_JUMP1              218
#define IDTB_JUMP2              219
#define IDTB_CUSTOMIZE          221
#define IDTB_ZOOM               222
#define IDTB_TOC_NEXT           223
#define IDTB_TOC_PREV           224

'' Notification codes

#define HHN_FIRST       (0U-860U)
#define HHN_LAST        (0U-879U)

#define HHN_NAVCOMPLETE   (HHN_FIRST-0)
#define HHN_TRACK         (HHN_FIRST-1)
#define HHN_WINDOW_CREATE (HHN_FIRST-2)

Type tagHHN_NOTIFY
    As NMHDR   hdr
    As PCSTR   pszUrl '' Multi-byte, null-terminated string
End Type

Type As tagHHN_NOTIFY HHN_NOTIFY

Type tagHH_POPUP
    As Integer   cbStruct      '' sizeof this structure
    As HINSTANCE hinst         '' instance handle for string resource
    As UINT      idString      '' string resource id, or text id if pszFile is specified in HtmlHelp call
    As LPCTSTR   pszText       '' used if idString is zero
    As Point     pt            '' top center of popup window
    As COLORREF  clrForeground '' use -1 for default
    As COLORREF  clrBackground '' use -1 for default
    As RECT      rcMargins     '' amount of space between edges of window and text, -1 for each member to ignore
    As LPCTSTR   pszFont       '' facename, point size, char set, BOLD ITALIC UNDERLINE
End Type

Type HH_POPUP As tagHH_POPUP

Type tagHH_AKLINK
    As Integer   cbStruct     '' sizeof this structure
    As BOOL      fReserved    '' must be FALSE (really!)
    As LPCTSTR   pszKeywords  '' semi-colon separated keywords
    As LPCTSTR   pszUrl       '' URL to jump to if no keywords found (may be NULL)
    As LPCTSTR   pszMsgText   '' Message text to display in MessageBox if pszUrl is NULL and no keyword match
    As LPCTSTR   pszMsgTitle  '' Message text to display in MessageBox if pszUrl is NULL and no keyword match
    As LPCTSTR   pszWindow    '' Window to display URL in
    As BOOL      fIndexOnFail '' Displays index if keyword lookup fails.
End Type

Type HH_AKLINK As tagHH_AKLINK

Enum
    HHWIN_NAVTYPE_TOC
    HHWIN_NAVTYPE_INDEX
    HHWIN_NAVTYPE_SEARCH,
    HHWIN_NAVTYPE_FAVORITES
    HHWIN_NAVTYPE_HISTORY   '' not implemented
    HHWIN_NAVTYPE_AUTHOR
    HHWIN_NAVTYPE_CUSTOM_FIRST = 11
End Enum

Enum
    IT_INCLUSIVE
    IT_EXCLUSIVE
    IT_HIDDEN
End Enum

Type tagHH_ENUM_IT
    As Integer   cbStruct          '' size of this structure
    As Integer   iType             '' the type of the information type ie. Inclusive, Exclusive, or Hidden
    As LPCSTR    pszCatName        '' Set to the name of the Category to enumerate the info types in a category else NULL
    As LPCSTR    pszITName         '' volitile pointer to the name of the infotype. Allocated by call. Caller responsible for freeing
    As LPCSTR    pszITDescription  '' volitile pointer to the description of the infotype.
End Type

Type As tagHH_ENUM_IT HH_ENUM_IT
Type As tagHH_ENUM_IT Ptr PHH_ENUM_IT

Type tagHH_ENUM_CAT
    As Integer   cbStruct          '' size of this structure
    As LPCSTR    pszCatName        '' volitile pointer to the category name
    As LPCSTR    pszCatDescription '' volitile pointer to the category description
End Type

Type As tagHH_ENUM_CAT HH_ENUM_CAT
Type As tagHH_ENUM_CAT Ptr PHH_ENUM_CAT

Type tagHH_SET_INFOTYPE
    As Integer   cbStruct          '' the size of this structure
    As LPCSTR    pszCatName        '' the name of the category, if any, the InfoType is a member of.
    As LPCSTR    pszInfoTypeName   '' the name of the info type to add to the filter
End Type

Type As tagHH_SET_INFOTYPE HH_SET_INFOTYPE
Type As tagHH_SET_INFOTYPE Ptr PHH_SET_INFOTYPE

Type As DWORD HH_INFOTYPE
Type As HH_INFOTYPE Ptr PHH_INFOTYPE

Enum
    HHWIN_NAVTAB_TOP
    HHWIN_NAVTAB_LEFT
    HHWIN_NAVTAB_BOTTOM
End Enum

#define HH_MAX_TABS 19  '' maximum number of tabs

Enum
    HH_TAB_CONTENTS
    HH_TAB_INDEX
    HH_TAB_SEARCH
    HH_TAB_FAVORITES
    HH_TAB_HISTORY
    HH_TAB_AUTHOR

    HH_TAB_CUSTOM_FIRST = 11
    HH_TAB_CUSTOM_LAST = HH_MAX_TABS
End Enum

#define HH_MAX_TABS_CUSTOM (HH_TAB_CUSTOM_LAST - HH_TAB_CUSTOM_FIRST + 1)

'' HH_DISPLAY_SEARCH Command Related Structures and Constants

#define HH_FTS_DEFAULT_PROXIMITY (-1)

Type tagHH_FTS_QUERY
    As Integer cbStruct        '' Sizeof structure in bytes.
    As BOOL    fUniCodeStrings '' TRUE if all strings are unicode.
    As LPCTSTR pszSearchQuery  '' String containing the search query.
    As Long    iProximity      '' Word proximity.
    As BOOL    fStemmedSearch  '' TRUE for StemmedSearch only.
    As BOOL    fTitleOnly      '' TRUE for Title search only.
    As BOOL    fExecute        '' TRUE to initiate the search.
    As LPCTSTR pszWindow       '' Window to display in
End Type
Type As tagHH_FTS_QUERY HH_FTS_QUERY

'' HH_WINTYPE Structure

Type tagHH_WINTYPE
    As Integer cbStruct        '' IN: size of this structure including all Information Types
    As BOOL    fUniCodeStrings '' IN/OUT: TRUE if all strings are in UNICODE
    As LPCTSTR pszType         '' IN/OUT: Name of a type of window
    As DWORD   fsValidMembers  '' IN: Bit flag of valid members (HHWIN_PARAM_)
    As DWORD   fsWinProperties '' IN/OUT: Properties/attributes of the window (HHWIN_)

    As LPCTSTR pszCaption      '' IN/OUT: Window title
    As DWORD   dwStyles        '' IN/OUT: Window styles
    As DWORD   dwExStyles      '' IN/OUT: Extended Window styles
    As RECT    rcWindowPos     '' IN: Starting position, OUT: current position
    As Integer nShowState      '' IN: show state (e.g., SW_SHOW)

    As HWND  hwndHelp          '' OUT: window handle
    As HWND  hwndCaller        '' OUT: who called this window

    As HH_INFOTYPE Ptr paInfoTypes  '' IN: Pointer to an array of Information Types

    '' The following members are only valid if HHWIN_PROP_TRI_PANE is set

    As HWND    hwndToolBar      '' OUT: toolbar window in tri-pane window
    As HWND    hwndNavigation   '' OUT: navigation window in tri-pane window
    As HWND    hwndHTML         '' OUT: window displaying HTML in tri-pane window
    As Integer iNavWidth        '' IN/OUT: width of navigation window
    As RECT    rcHTML           '' OUT: HTML window coordinates

    As LPCTSTR pszToc         '' IN: Location of the table of contents file
    As LPCTSTR pszIndex       '' IN: Location of the index file
    As LPCTSTR pszFile        '' IN: Default location of the html file
    As LPCTSTR pszHome        '' IN/OUT: html file to display when Home button is clicked
    As DWORD   fsToolBarFlags '' IN: flags controling the appearance of the toolbar
    As BOOL    fNotExpanded   '' IN: TRUE/FALSE to contract or expand, OUT: current state
    As Integer curNavType     '' IN/OUT: UI to display in the navigational pane
    As Integer tabpos         '' IN/OUT: HHWIN_NAVTAB_TOP, HHWIN_NAVTAB_LEFT, or HHWIN_NAVTAB_BOTTOM
    As Integer idNotify       '' IN: ID to use for WM_NOTIFY messages
    As Byte    tabOrder(HH_MAX_TABS + 1)    '' IN/OUT: tab order: Contents, Index, Search, History, Favorites, Reserved 1-5, Custom tabs
    As Integer cHistory       '' IN/OUT: number of history items to keep (default is 30)
    As LPCTSTR pszJump1       '' Text for HHWIN_BUTTON_JUMP1
    As LPCTSTR pszJump2       '' Text for HHWIN_BUTTON_JUMP2
    As LPCTSTR pszUrlJump1    '' URL for HHWIN_BUTTON_JUMP1
    As LPCTSTR pszUrlJump2    '' URL for HHWIN_BUTTON_JUMP2
    As RECT    rcMinSize      '' Minimum size for window (ignored in version 1)
    As Integer cbInfoTypes    '' size of paInfoTypes
    As LPCTSTR pszCustomTabs  '' multiple zero-terminated strings
End Type

Type As tagHH_WINTYPE HH_WINTYPE
Type As tagHH_WINTYPE Ptr PHH_WINTYPE

Enum
    HHACT_TAB_CONTENTS
    HHACT_TAB_INDEX
    HHACT_TAB_SEARCH
    HHACT_TAB_HISTORY
    HHACT_TAB_FAVORITES

    HHACT_EXPAND
    HHACT_CONTRACT
    HHACT_BACK
    HHACT_FORWARD
    HHACT_STOP
    HHACT_REFRESH
    HHACT_HOME
    HHACT_SYNC
    HHACT_OPTIONS
    HHACT_PRINT
    HHACT_HIGHLIGHT
    HHACT_CUSTOMIZE
    HHACT_JUMP1
    HHACT_JUMP2
    HHACT_ZOOM
    HHACT_TOC_NEXT
    HHACT_TOC_PREV
    HHACT_NOTES

    HHACT_LAST_ENUM
End Enum

Type tagHHNTRACK
    As NMHDR          hdr
    As PCSTR          pszCurUrl  '' Multi-byte, null-terminated string
    As Integer        idAction   '' HHACT_ value
    As HH_WINTYPE Ptr phhWinType '' Current window type structure
End Type

Type As tagHHNTRACK HHNTRACK

Declare Function HtmlHelpA Alias "HtmlHelpA" ( ByVal hwndCaller As HWND, ByVal pszFile As LPCSTR, ByVal uCommand As UINT, ByVal dwData As DWORD_PTR ) As HWND
Declare Function HtmlHelpW Alias "HtmlHelpW" ( ByVal hwndCaller As HWND, ByVal pszFile As LPCWSTR, ByVal uCommand As UINT, ByVal dwData As DWORD_PTR ) As HWND

#Ifdef UNICODE
#define HtmlHelp  HtmlHelpW
#Else
#define HtmlHelp  HtmlHelpA
#EndIf '' !UNICODE

'' Use the following for GetProcAddress to load from hhctrl.ocx

#define ATOM_HTMLHELP_API_ANSI    Cast(LPTSTR,(Cast(DWORD,(Cast(WORD,(14))))))
#define ATOM_HTMLHELP_API_UNICODE Cast(LPTSTR,(Cast(DWORD,(Cast(WORD,(15))))))

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''
'' Global Control Properties. 
''
Enum tagHH_GPROPID
    HH_GPROPID_SINGLETHREAD=1       '' VARIANT_BOOL: True for single thread
    HH_GPROPID_TOOLBAR_MARGIN       '' long: Provides a left/right margin around the toolbar.
    HH_GPROPID_UI_LANGUAGE          '' long: LangId of the UI.
    HH_GPROPID_CURRENT_SUBSET       '' BSTR: Current subset.
    HH_GPROPID_CONTENT_LANGUAGE     '' long: LandId for desired content.
End Enum

Type As tagHH_GPROPID HH_GPROPID

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''
'' Global Property structure
''

Type tagHH_GLOBAL_PROPERTY
    As HH_GPROPID  id
    As VARIANT     var_
End Type

Type As tagHH_GLOBAL_PROPERTY HH_GLOBAL_PROPERTY 


End Extern

#endif '' __HTMLHELP_H__
