#Define NULL 0

Type ProjPub_FileTypeContextMenu
	Verb As ZString Ptr
	ItemText As ZString Ptr
	Command As ZString Ptr
	Next As ProjPub_FileTypeContextMenu Ptr
End Type

Type ProjPub_FileType
	Ext As ZString Ptr
	AppIDKey As ZString Ptr
	Description As ZString Ptr
	DefaultIcon As ZString Ptr
	Next As ProjPub_FileType Ptr
	ContextMenu As ProjPub_FileTypeContextMenu
End Type

Declare Sub RemoveFileType( ByVal Head As ProjPub_FileType Ptr, ByVal id As Integer )
Declare Sub RemoveAllFileTypes( ByVal Head As ProjPub_FileType Ptr )
Declare Function GetFileTypesNum( ByVal Head As ProjPub_FileType Ptr ) As Integer
Declare Sub InsertFileTypeToEnd( ByVal Head As ProjPub_FileType Ptr, ByRef FileTypeExt As Const String, ByRef FileTypeAppIDKey As Const String, ByRef FileTypeDescription As Const String, ByRef FileTypeDefaultIcon As Const String )
Declare Sub InsertFileType( ByVal Head As ProjPub_FileType Ptr, ByVal Id As Integer, ByRef FileTypeExt As Const String, ByRef FileTypeAppIDKey As Const String, ByRef FileTypeDescription As Const String, ByRef FileTypeDefaultIcon As Const String )
Declare Sub ReverseFileTypes( ByVal Head As ProjPub_FileType Ptr, ByVal Id As Integer )
Declare Sub SetNewFileTypeExt( ByVal Head As ProjPub_FileType Ptr, ByVal Id As Integer, ByRef FileTypeExt As Const String )
Declare Sub SetNewFileTypeAppIdKey( ByVal Head As ProjPub_FileType Ptr, ByVal Id As Integer, ByRef FileTypeAppIdKey As Const String )
Declare Sub SetNewFileTypeDescription( ByVal Head As ProjPub_FileType Ptr, ByVal Id As Integer, ByRef FileTypeDescription As Const String )
Declare Sub SetNewFileTypeDefaultIcon( ByVal Head As ProjPub_FileType Ptr, ByVal Id As Integer, ByRef FileTypeDefaultIcon As Const String )
Declare Function GetFileType( ByVal Head As ProjPub_FileType Ptr, ByVal Id As Integer ) As ProjPub_FileType Ptr
Declare Sub RemoveFileTypeContextMenuInFileType( ByVal FileType As ProjPub_FileType Ptr, ByVal id As Integer )
Declare Sub RemoveAllFileTypeContextMenusInFileType( ByVal FileType As ProjPub_FileType Ptr )
Declare Sub InsertFileTypeContextMenuToFileTypeToEnd( ByVal FileType As ProjPub_FileType Ptr, ByRef FileTypeContextMenuVerb As Const String, ByRef FileTypeContextMenuItemText As Const String, ByRef FileTypeContextMenuCommand As Const String )
Declare Sub InsertFileTypeContextMenuToFileType( ByVal FileType As ProjPub_FileType Ptr, ByVal Id As Integer, ByRef FileTypeContextMenuVerb As Const String, ByRef FileTypeContextMenuItemText As Const String, ByRef FileTypeContextMenuCommand As Const String )
Declare Function GetFileTypeContextMenusInFileTypeNum( ByVal FileType As ProjPub_FileType Ptr ) As Integer
Declare Sub ReverseFileTypeContextMenusInFileType( ByVal FileType As ProjPub_FileType Ptr, ByVal Id As Integer )
Declare Sub SetNewFileTypeContextMenuVerb( ByVal FileType As ProjPub_FileType Ptr, ByVal Id As Integer, ByRef FileTypeContextMenuVerb As Const String )
Declare Sub SetNewFileTypeContextMenuItemText( ByVal FileType As ProjPub_FileType Ptr, ByVal Id As Integer, ByRef FileTypeContextMenuItemText As Const String )
Declare Sub SetNewFileTypeContextMenuCommand( ByVal FileType As ProjPub_FileType Ptr, ByVal Id As Integer, ByRef FileTypeContextMenuCommand As Const String )

Sub RemoveFileType( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal id As Integer _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head
	Dim PrevFileType As ProjPub_FileType Ptr

	For i As Integer = 0 To id
		If CurFileType = NULL Then Return
		PrevFileType = CurFileType
		CurFileType = CurFileType->Next
	Next

	PrevFileType->Next=CurFileType->Next
	Delete[] CurFileType->Ext
	Delete[] CurFileType->AppIDKey
	Delete[] CurFileType->Description
	Delete[] CurFileType->DefaultIcon
	RemoveAllFileTypeContextMenusInFileType( CurFileType )
	Delete CurFileType

End Sub

Sub RemoveAllFileTypes( _
	ByVal Head As ProjPub_FileType Ptr _
	)

	Dim NextFileType As ProjPub_FileType Ptr

	Do While Head->Next <> NULL
		NextFileType=Head->Next->Next
		Delete[] Head->Next->Ext
		Delete[] Head->Next->AppIDKey
		Delete[] Head->Next->Description
		Delete[] Head->Next->DefaultIcon
		RemoveAllFileTypeContextMenusInFileType( Head->Next )
		Delete Head->Next
		Head->Next=NextFileType
	Loop

End Sub

Function GetFileTypesNum( _
	ByVal Head As ProjPub_FileType Ptr _
	) As Integer

	Dim CurFileType As ProjPub_FileType Ptr = Head->Next
	Dim Num As Integer

	Do While CurFileType <> NULL
		CurFileType = CurFileType->Next
		Num += 1
	Loop

	Return Num

End Function

Sub InsertFileTypeToEnd( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByRef FileTypeExt As Const String, _
	ByRef FileTypeAppIDKey As Const String, _
	ByRef FileTypeDescription As Const String, _
	ByRef FileTypeDefaultIcon As Const String _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head

	Do While CurFileType->Next <> NULL
		CurFileType = CurFileType->Next
	Loop

	CurFileType->Next = New ProjPub_FileType
	CurFileType->Next->Ext = New Byte [Len( FileTypeExt ) + 1]
	*CurFileType->Next->Ext = FileTypeExt
	CurFileType->Next->AppIDKey = New Byte [Len( FileTypeAppIDKey ) + 1]
	*CurFileType->Next->AppIDKey = FileTypeAppIDKey
	CurFileType->Next->Description = New Byte [Len( FileTypeDescription ) + 1]
	*CurFileType->Next->Description = FileTypeDescription
	CurFileType->Next->DefaultIcon = New Byte [Len( FileTypeDefaultIcon ) + 1]
	*CurFileType->Next->DefaultIcon = FileTypeDefaultIcon
	CurFileType->Next->Next = NULL

End Sub


Sub InsertFileType( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeExt As Const String, _
	ByRef FileTypeAppIDKey As Const String, _
	ByRef FileTypeDescription As Const String, _
	ByRef FileTypeDefaultIcon As Const String _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head
	Dim TempFileType As ProjPub_FileType Ptr
	Dim CurFileTypeId As Integer = 0

	Do Until CurFileTypeId = Id
		If CurFileType->Next <> NULL Then
			CurFileType = CurFileType->Next
		Else
			Return
		End If
		CurFileTypeId += 1
	Loop

	TempFileType=CurFileType->Next
	CurFileType->Next=New ProjPub_FileType
	CurFileType->Next->Ext = New Byte [Len( FileTypeExt ) + 1]
	*CurFileType->Next->Ext = FileTypeExt
	CurFileType->Next->AppIDKey = New Byte [Len( FileTypeAppIDKey ) + 1]
	*CurFileType->Next->AppIDKey = FileTypeAppIDKey
	CurFileType->Next->Description = New Byte [Len( FileTypeDescription ) + 1]
	*CurFileType->Next->Description = FileTypeDescription
	CurFileType->Next->DefaultIcon = New Byte [Len( FileTypeDefaultIcon ) + 1]
	*CurFileType->Next->DefaultIcon = FileTypeDefaultIcon
	CurFileType->Next->Next=TempFileType

End Sub
'/


Sub ReverseFileTypes( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer _
	)

	Dim PrevFileType As ProjPub_FileType Ptr = Head
	Dim CurFileType As ProjPub_FileType Ptr
	Dim NextFileType As ProjPub_FileType Ptr
	Dim TempFileType As ProjPub_FileType Ptr

	If Id+1>=GetFileTypesNum( Head ) Then Return
	For i As Integer = 0 To Id-1
		PrevFileType = PrevFileType->Next
	Next

	CurFileType=PrevFileType->Next
	NextFileType=CurFileType->Next
	TempFileType=PrevFileType->Next
	PrevFileType->Next=CurFileType->Next
	CurFileType->Next=NextFileType->Next
	NextFileType->Next=TempFileType
	
End Sub
'/


Sub SetNewFileTypeExt( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeExt As Const String _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head

	For i As Integer = 0 To id
		If CurFileType <> NULL Then
			CurFileType = CurFileType->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileType->Ext
	CurFileType->Ext=New Byte [Len( FileTypeExt ) + 1]
	*CurFileType->Ext=FileTypeExt

End Sub


Sub SetNewFileTypeAppIdKey( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeAppIdKey As Const String _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head

	For i As Integer = 0 To id
		If CurFileType <> NULL Then
			CurFileType = CurFileType->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileType->AppIdKey
	CurFileType->AppIdKey=New Byte [Len( FileTypeAppIdKey ) + 1]
	*CurFileType->AppIdKey=FileTypeAppIdKey

End Sub

Sub SetNewFileTypeDescription( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeDescription As Const String _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head

	For i As Integer = 0 To id
		If CurFileType <> NULL Then
			CurFileType = CurFileType->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileType->Description
	CurFileType->Description=New Byte [Len( FileTypeDescription ) + 1]
	*CurFileType->Description=FileTypeDescription

End Sub

Sub SetNewFileTypeDefaultIcon( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeDefaultIcon As Const String _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head

	For i As Integer = 0 To id
		If CurFileType <> NULL Then
			CurFileType = CurFileType->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileType->DefaultIcon
	CurFileType->DefaultIcon=New Byte [Len( FileTypeDefaultIcon ) + 1]
	*CurFileType->DefaultIcon=FileTypeDefaultIcon

End Sub

'/

Function GetFileType( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer _
	) As ProjPub_FileType Ptr

	Dim CurFileType As ProjPub_FileType Ptr = Head

	For i As Integer = 0 To id
		If CurFileType <> NULL Then
			CurFileType = CurFileType->Next
		Else
			Return NULL
		End If
	Next

	Return CurFileType

End Function

Sub RemoveFileTypeContextMenuInFileType( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByVal id As Integer _
	)

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu
	Dim PrevFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr

	For i As Integer = 0 To id
		If CurFileTypeContextMenu = NULL Then Return
		PrevFileTypeContextMenu = CurFileTypeContextMenu
		CurFileTypeContextMenu = CurFileTypeContextMenu->Next
	Next

	PrevFileTypeContextMenu->Next=CurFileTypeContextMenu->Next
	Delete[] CurFileTypeContextMenu->Verb
	Delete[] CurFileTypeContextMenu->ItemText
	Delete[] CurFileTypeContextMenu->Command
	Delete CurFileTypeContextMenu

End Sub

Sub RemoveAllFileTypeContextMenusInFileType( _
	ByVal FileType As ProjPub_FileType Ptr _
	)

	Dim NextFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr

	Do While (@FileType->ContextMenu)->Next <> NULL
		NextFileTypeContextMenu=(@FileType->ContextMenu)->Next->Next
		Delete[] (@FileType->ContextMenu)->Next->Verb
		Delete[] (@FileType->ContextMenu)->Next->ItemText
		Delete[] (@FileType->ContextMenu)->Next->Command
		Delete (@FileType->ContextMenu)->Next
		(@FileType->ContextMenu)->Next=NextFileTypeContextMenu
	Loop

End Sub

Sub InsertFileTypeContextMenuToFileTypeToEnd( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByRef FileTypeContextMenuVerb As Const String, _
	ByRef FileTypeContextMenuItemText As Const String, _
	ByRef FileTypeContextMenuCommand As Const String _
	)

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu

	Do While CurFileTypeContextMenu->Next <> NULL
		CurFileTypeContextMenu = CurFileTypeContextMenu->Next
	Loop

	CurFileTypeContextMenu->Next = New ProjPub_FileTypeContextMenu
	CurFileTypeContextMenu->Next->Verb = New Byte [Len( FileTypeContextMenuVerb ) + 1]
	*CurFileTypeContextMenu->Next->Verb = FileTypeContextMenuVerb
	CurFileTypeContextMenu->Next->ItemText = New Byte [Len( FileTypeContextMenuItemText ) + 1]
	*CurFileTypeContextMenu->Next->ItemText = FileTypeContextMenuItemText
	CurFileTypeContextMenu->Next->Command = New Byte [Len( FileTypeContextMenuCommand ) + 1]
	*CurFileTypeContextMenu->Next->Command = FileTypeContextMenuCommand
	CurFileTypeContextMenu->Next->Next = NULL

End Sub


Sub InsertFileTypeContextMenuToFileType( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeContextMenuVerb As Const String, _
	ByRef FileTypeContextMenuItemText As Const String, _
	ByRef FileTypeContextMenuCommand As Const String _
	)

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu
	Dim TempFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr
	Dim CurFileTypeContextMenuId As Integer = 0

	Do Until CurFileTypeContextMenuId = Id
		If CurFileTypeContextMenu->Next <> NULL Then
			CurFileTypeContextMenu = CurFileTypeContextMenu->Next
		Else
			Return
		End If
		CurFileTypeContextMenuId += 1
	Loop

	TempFileTypeContextMenu=CurFileTypeContextMenu->Next
	CurFileTypeContextMenu->Next=New ProjPub_FileTypeContextMenu
	CurFileTypeContextMenu->Next->Verb = New Byte [Len( FileTypeContextMenuVerb ) + 1]
	*CurFileTypeContextMenu->Next->Verb = FileTypeContextMenuVerb
	CurFileTypeContextMenu->Next->ItemText = New Byte [Len( FileTypeContextMenuItemText ) + 1]
	*CurFileTypeContextMenu->Next->ItemText = FileTypeContextMenuItemText
	CurFileTypeContextMenu->Next->Command = New Byte [Len( FileTypeContextMenuCommand ) + 1]
	*CurFileTypeContextMenu->Next->Command = FileTypeContextMenuCommand
	CurFileTypeContextMenu->Next->Next=TempFileTypeContextMenu

End Sub

Function GetFileTypeContextMenusInFileTypeNum( _
	ByVal FileType As ProjPub_FileType Ptr _
	) As Integer

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = (@FileType->ContextMenu)->Next
	Dim Num As Integer

	Do While CurFileTypeContextMenu <> NULL
		CurFileTypeContextMenu = CurFileTypeContextMenu->Next
		Num += 1
	Loop

	Return Num

End Function

Sub ReverseFileTypeContextMenusInFileType( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByVal Id As Integer _
	)

	Dim PrevFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu
	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr
	Dim NextFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr
	Dim TempFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr

	If Id+1>=GetFileTypeContextMenusInFileTypeNum( FileType ) Then Return
	For i As Integer = 0 To Id-1
		PrevFileTypeContextMenu = PrevFileTypeContextMenu->Next
	Next

	CurFileTypeContextMenu=PrevFileTypeContextMenu->Next
	NextFileTypeContextMenu=CurFileTypeContextMenu->Next
	TempFileTypeContextMenu=PrevFileTypeContextMenu->Next
	PrevFileTypeContextMenu->Next=CurFileTypeContextMenu->Next
	CurFileTypeContextMenu->Next=NextFileTypeContextMenu->Next
	NextFileTypeContextMenu->Next=TempFileTypeContextMenu
	
End Sub


Sub SetNewFileTypeContextMenuVerb( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeContextMenuVerb As Const String _
	)

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu

	For i As Integer = 0 To id
		If CurFileTypeContextMenu <> NULL Then
			CurFileTypeContextMenu = CurFileTypeContextMenu->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileTypeContextMenu->Verb
	CurFileTypeContextMenu->Verb=New Byte [Len( FileTypeContextMenuVerb ) + 1]
	*CurFileTypeContextMenu->Verb=FileTypeContextMenuVerb

End Sub

Sub SetNewFileTypeContextMenuItemText( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeContextMenuItemText As Const String _
	)

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu

	For i As Integer = 0 To id
		If CurFileTypeContextMenu <> NULL Then
			CurFileTypeContextMenu = CurFileTypeContextMenu->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileTypeContextMenu->ItemText
	CurFileTypeContextMenu->ItemText=New Byte [Len( FileTypeContextMenuItemText ) + 1]
	*CurFileTypeContextMenu->ItemText=FileTypeContextMenuItemText

End Sub

Sub SetNewFileTypeContextMenuCommand( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeContextMenuCommand As Const String _
	)

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu

	For i As Integer = 0 To id
		If CurFileTypeContextMenu <> NULL Then
			CurFileTypeContextMenu = CurFileTypeContextMenu->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileTypeContextMenu->Command
	CurFileTypeContextMenu->Command=New Byte [Len( FileTypeContextMenuCommand ) + 1]
	*CurFileTypeContextMenu->Command=FileTypeContextMenuCommand

End Sub
